#include "fxlib.h"
#include "stdlib.h"
#include "math.h"

//#define VRAM (char*)0x88004991
#define NB_MAX 500 //nombre maximal de trait
char* VRam_Base();

char* vram; //contient l'adresse de la VRAM pour afficher des choses plus rapidement
int nb; //nombre actuel de traits

traitH(char x, char y) //trace un trait horizontal de 8 pixels tres rapidement
{
    unsigned char a = 255;
    a = 255 >> x%8;
    vram[16*y+x/8] |= a;
    vram[16*y+x/8+1] |= ~a;
}

traitV(char x, char y) //trace un trait vertical de 8 pixels tres rapidement
{
    unsigned char i, j = 128>>x%8, *ligne;
    ligne = vram + y*16+x/8;
    for(i=0 ; i<8 ; i++)
    {
        *ligne |= j;
        ligne += 16;
    }
}

DrawSprite(unsigned char *sprite, int x, int y) //Pour afficher les balles
{
    unsigned short ligne;
    char i, decalage, *ecran, *adresseLigne = (char*)&ligne;
    decalage = 8 - x%8;
    x /= 8;
    ecran = (void*)(vram + 16*y + x);
    for(i=0 ; i<8 ; i++)
    {
        ligne = sprite[i] << decalage;
        ecran[0] |= adresseLigne[0];
        ecran[1] |= adresseLigne[1];
        ecran += 16;
    }
}

nouveauTrait(char *x, char *y, char *type, char xBall, char yBall) //cre un nouveau trait
{
    nb++;
    if(nb == NB_MAX) return;
    type[nb] = (2*(rand()%2)-1)*(rand()%2+1);
    x[nb] = rand()%117+2;
    y[nb] = rand()%53+2;
}

nouvelleCible(char *x, char *y, char x1, char y1) //donne une position alatoire a la cible
{
    do
    {
        *x = rand()%119+1;
        *y = rand()%55+1;
    }while(sqrt(carre(x1-*x-2)+carre(y1-*y-2)) < 10);
}

int carre(int i)
{
    return i*i;
}

char *int2str(char *c, int n) //crit un nombre dans une chaine
{
    int i = 0, l = 0;
    if(n==0)
    {
        c[0] = '0';
        c[1] = 0;
    }
    else
    {
        for(i=n ; i ; i/=10)
            l++;
        c[l] = 0;
        for(i=n ; i ; i/=10)
            c[--l] = i%10+'0';
    }
    return c;
}

unsigned char jeu(char niveau, char vitesse) //fonction principale du jeu
{
    char x[NB_MAX], y[NB_MAX], type[NB_MAX+1] = {0}, xBall = 62, yBall = 30, xCible, yCible, alterne, continuer = 1;
    char balle[] = {96,176,240,96,0,0,0,0}, cible[] = {60,126,231,223,255,255,126,60};
    unsigned char score = 0;
    int i;

    nb = -1;
    nouvelleCible(&xCible, &yCible, xBall, yBall);
    while(continuer)
    {
        alterne = !alterne; //pour que les traits n'avancent qu'une fois sur deux
        Bdisp_AllClr_VRAM();
        for(i=0 ; i<16 ; i++)               //--
            vram[i] = vram[63*16+i] = 255;  //  |
        for(i=1 ; i<63 ; i++)               //  |
        {                                   //  }- dessine le cadre
            vram[16*i] = 128;               //  |
            vram[16*i+15] = 1;              //  |
        }                                   //--
        for(i=0 ; type[i] ; i++)
        {
            if(abs(type[i]) == 1) //si le trait est horizontal
            {
                if(alterne)
                {
                    x[i] += type[i];
                    if(x[i] == 1 || x[i] == 119)
                        type[i] *= -1;
                }
                if(y[i]>=yBall && y[i]<yBall+4 && x[i]-xBall>-8 && x[i]-xBall<4) continuer = 0;
                traitH(x[i], y[i]);
            }
            else //si le trait est vertical
            {
                if(alterne)
                {
                    y[i] += type[i]/2;
                    if(y[i] == 1 || y[i] == 55)
                        type[i] *= -1;
                }
                if(x[i]>=xBall && x[i]<xBall+4 && y[i]-yBall>-8 && y[i]-yBall<4) continuer = 0;
                traitV(x[i], y[i]);
            }
        }
        DrawSprite(balle, xBall, yBall);
        DrawSprite(cible, xCible, yCible);
        Bdisp_PutDisp_DD();

        if(xBall<1 || yBall<1 || xBall>123 || yBall>59) continuer = 0; //si la balle sort du cadre
        if(sqrt(carre(xBall-xCible-2)+carre(yBall-yCible-2)) < 6) //si la balle touche la cible
        {
            for(i=0 ; i<niveau ; i++)
                nouveauTrait(x, y, type, xBall, yBall);
            nouvelleCible(&xCible, &yCible, xBall, yBall);
            score++;
        }

        if(IsKeyDown(KEY_CTRL_UP)) yBall--;
        if(IsKeyDown(KEY_CTRL_DOWN)) yBall++;
        if(IsKeyDown(KEY_CTRL_LEFT)) xBall--;
        if(IsKeyDown(KEY_CTRL_RIGHT)) xBall++;
        if(IsKeyDown(KEY_CTRL_EXIT))
        {
            locate(8, 4);
            PrintRev(" Pause ");
            while(i != KEY_CTRL_EXE)
                GetKey(&i);
        }
        Sleep((3-vitesse)*10);
    }
    locate(6, 4);
    PrintRev(" Score: ");
    PrintRev(int2str(x, score));
    PrintRev(" ");
    Bdisp_PutDisp_DD();
    while(i != KEY_CTRL_EXE)
        GetKey(&i);
    return score;
}

ClearMenu() //affiche l'image de fond du menu
{
    int i, fond[256] = {0x0FFFFFFF,0xFFFFFFFF,0xFE000000,0,0x3FFFFFFF,0xFFFFFFFF,0xFF800000,0,0x7AAAAAAA,
    0xAAAAAAAA,0xABC001F0,0,0x74000000,0,0x5C007FE,0,0xE8FE3F0F,0xE38FE39C,0x72E01FFF,0x80000000,0xD5FF7F9F,
    0xF39FF39C,0x75603FC7,0xC0000000,0xE9FF7F9F,0xF39FF39C,0x72E07FC7,0xE0000000,0xD5C7701C,0x739C739C,
    0x7560F3C7,0xF0000000,0xE9C7701C,0x739C739E,0x72E1E3E7,0xF8000000,0xD5C7701C,0x739C739F,0x7561E3F7,
    0xFC000000,0xE9C77F1F,0xF39FF39F,0xF2E3C7FF,0xFE000000,0xD5FF7F9F,0xF39FF39F,0xF563C7FF,0xFF000000,
    0xE9FF3F9F,0xE39FE39D,0xF2E3CFFF,0xFF800000,0xD5FF039C,0x039FC39C,0xF563CFFF,0xFFC00000,0xE9C7039C,
    0x39DE39C,0x72E3CFFF,0xFFE00000,0xD5C77F9C,0x39CF39C,0x7563CFFF,0xFFF00000,0xE9C77F9C,0x39C7B9C,
    0x72E3C7FF,0xFFF80000,0xF5C73F1C,0x39C3B9C,0x75E3E3FF,0xFFFC0000,0x6A000000,0,0xAC1E1FF,0xFFFC0000,
    0x7D555555,0x55555555,0x57C1F0FF,0xFFFE0000,0x3FFFFFFF,0xFFFFFFFF,0xFF80F87F,0xFFFF0000,0xFFFFFFF,
    0xFFFFFFFF,0xFE007C3F,0xFFF78000,0,0,0x3E1F,0xFFE3C000,0,0,0x1F0F,0xFFC1E000,0,0,0xF87,0xFF80F000,0,0,
    0x7C3,0xFF007800,0,0,0x3E1,0xFE003C00,0,0,0x1F1,0xFC001E00,0,0,0xF9,0xF8000F00,0,0,0x7B,0xF0000780,0,0,
    0x3F,0xE00003C0,0,0,0x1F,0xC00001C0,0,0,0x1F,0x800000E0,0,0,0xF,0x800000E0,0,0,0x7F,0xC00000E0,0,0,
    0x7FFF,0xE00000E0,0,0,0x3FFFF,0xFFC000E0,0,0,0xFE003,0xFFF000E0,0,0,0x3E000F,0x707C00E0,0,0,0x78001D,
    0xE01C01C0,0,0,0x70007B,0x800C01C0,0,0,0x7000EF,0xC0380,0,0,0x7C03DC,0x3C0780,0,0,0x7F8778,0x1FE0F00,0,
    0,0x77FEE0,0x3FEE3E00,0,0,0x7079FF,0xFE0FF800,0,0,0x7019FF,0x800FF000,0,0,0x701B80,0xF0000,0,0,0x701F80,
    0xE0000,0,0,0x700000,0xE0000,0,0,0x700000,0xE0000,0,0,0x700000,0xE0000,0,0,0x700000,0xE0000,0,0,
    0x7C0000,0x3C0000,0,0,0x3F8000,0x1FC0000,0,0,0xFFF00,0x7FF00000,0,0,0x3FFFF,0xFFC00000,0,0,0x3FFF,0xFC000000};
    char *b = (char*)fond;
    for(i=0 ; i<1024 ; i++)
        vram[i] = b[i];
}

int AddIn_main(int isAppli, unsigned short OptionNum)
{
    int i, j=0;
    unsigned char niveau = 5, vitesse = 2, a[4], records[9][3] = {0}, score, *menu[] = {"-Jouer-", "Niveau ", "Vitesse", "Records"};
    FONTCHARACTER fichier[] = {'\\','\\','f','l','s','0','\\','a','s','p','i','r','i','n','e','.','d','a','t',0};
	vram = VRam_Base();

    i = Bfile_OpenFile(fichier, _OPENMODE_READ);
    if(i>=0) //si le fichier existe, on copie les scores dans le tableau
    {
        Bfile_ReadFile(i, records, 3*9, 0);
        Bfile_CloseFile(i);
    }

    while(1)
    {
        ClearMenu();
        for(i=0 ; i<4 ; i++)
        {
            locate(2, i+4);
            if(i==j) PrintRev(menu[i]);
            else Print(menu[i]);
        }
        locate(10, 5);
        PrintRev(int2str(a, niveau));
        locate(10, 6);
        PrintRev(int2str(a, vitesse));
        locate(10, 7);
        PrintRev(int2str(a, records[niveau-1][vitesse-1]));
        GetKey(&i);
        switch(i)
        {
            case KEY_CTRL_UP:
                if(j) j--;
                break;
            case KEY_CTRL_DOWN:
                if(j<3) j++;
                break;
            case KEY_CTRL_LEFT:
                if(j==1 && niveau > 1) niveau--;
                if(j==2 && vitesse > 1) vitesse--;
                break;
            case KEY_CTRL_RIGHT:
                if(j==1 && niveau < 9) niveau++;
                if(j==2 && vitesse < 3) vitesse++;
                break;
            case KEY_CTRL_EXE:
                if(j == 0)
                {
                    score = jeu(niveau, vitesse);
                    if(score > records[niveau-1][vitesse-1]) //si le score est un nouveau record, on copie le tableau dans le fichier
                    {
                        records[niveau-1][vitesse-1] = score;
                        Bfile_DeleteFile(fichier);
                        Bfile_CreateFile(fichier, 3*9);
                        i = Bfile_OpenFile(fichier, _OPENMODE_WRITE);
                        Bfile_WriteFile(i, records, 3*9);
                        Bfile_CloseFile(i);
                    }
                }
                break;
        }
    }
    return 1;
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section
